## zeromq 2.0.6beta.dfsg

=== openpgm/pgm/SConstruct ===
# -*- mode: python -*-
# OpenPGM build script

import os
import time
import sys

EnsureSConsVersion( 1, 0 )
SConsignFile('scons.signatures');

vars = Variables()
vars.AddVariables (
	EnumVariable ('BUILD', 'build environment', 'debug',
			allowed_values=('release', 'debug', 'profile')),
	EnumVariable ('BRANCH', 'branch prediction', 'none',
			allowed_values=('none', 'profile', 'seed')),
	EnumVariable ('COVERAGE', 'test coverage', 'none',
			allowed_values=('none', 'full')),
	EnumVariable ('WITH_HISTOGRAMS', 'Runtime statistical information', 'true',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_HTTP', 'HTTP administration', 'true',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_SNMP', 'SNMP administration', 'true',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_CHECK', 'Check test system', 'false',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_TEST', 'Network test system', 'false',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_EXAMPLES', 'Examples', 'true',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_NCURSES', 'NCURSES examples', 'false',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_PROTOBUF', 'Google Protocol Buffer examples', 'false',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_PLUS', 'libpgmplus GPL library', 'false',
			allowed_values=('true', 'false')),
)

#-----------------------------------------------------------------------------
# Dependencies

env = Environment();

def CheckPKGConfig(context, version):
	context.Message( 'Checking for pkg-config... ' )
	ret = context.TryAction('pkg-config --atleast-pkgconfig-version=%s' % version)[0]
	context.Result( ret )
	return ret

def CheckPKG(context, name):
	context.Message( 'Checking for %s... ' % name )
	ret = context.TryAction('pkg-config --exists \'%s\'' % name)[0]
	context.Result( ret )
	return ret

conf = Configure(env, custom_tests = { 'CheckPKGConfig' : CheckPKGConfig,
				       'CheckPKG' : CheckPKG })

if not conf.CheckPKGConfig('0.15.0'):
	print 'pkg-config >= 0.15.0 not found.'
	Exit(1)

if not conf.CheckPKG('glib-2.0 >= 2.10'):
	print 'glib-2.0 >= 2.10 not found.'
	Exit(1)

if not conf.CheckPKG('gthread-2.0'):
	print 'gthread-2.0 not found.'
	Exit(1)

if not conf.CheckPKG('libsoup-2.4'):
	print 'libsoup-2.4 not found.'
	Exit(1)

env = conf.Finish();

#-----------------------------------------------------------------------------
# Platform specifics

env = Environment(
	variables = vars,
	ENV = os.environ,
	CCFLAGS = [	'-pipe',
			'-Wall',
				'-Wextra',
				'-Wfloat-equal',
				'-Wshadow',
				'-Wunsafe-loop-optimizations',
				'-Wpointer-arith',
				'-Wbad-function-cast',
				'-Wcast-qual',
				'-Wcast-align',
				'-Wwrite-strings',
				'-Waggregate-return',
				'-Wstrict-prototypes',
				'-Wold-style-definition',
				'-Wmissing-prototypes',
				'-Wmissing-declarations',
				'-Wmissing-noreturn',
				'-Wmissing-format-attribute',
				'-Wredundant-decls',
				'-Wnested-externs',
				'-Winline',
			'-pedantic',
			'-std=gnu99',
			'--param', 'max-inline-insns-single=600',
			'-D_REENTRANT',
			'-D_GNU_SOURCE',
			'-D__need_IOV_MAX',
			'-DCONFIG_HAVE_PSELECT',
			'-DCONFIG_HAVE_POLL',
			'-DCONFIG_HAVE_PPOLL',
			'-DCONFIG_HAVE_EPOLL',
			'-DCONFIG_HAVE_CLOCK_GETTIME',
			'-DCONFIG_HAVE_CLOCK_NANOSLEEP',
			'-DCONFIG_HAVE_NANOSLEEP',
			'-DCONFIG_HAVE_USLEEP',
			'-DCONFIG_HAVE_RTC',
			'-DCONFIG_HAVE_TSC',
			'-DCONFIG_HAVE_IFR_NETMASK',
			'-DCONFIG_HAVE_GETIFADDRS',
			'-DCONFIG_HAVE_GETHOSTBYNAME2',
			'-DCONFIG_HAVE_GETPROTOBYNAME_R',
			'-DCONFIG_HAVE_MCAST_JOIN',
			'-DCONFIG_HAVE_IP_MREQN',
			'-DCONFIG_HAVE_SPRINTF_GROUPING',
			'-DCONFIG_HAVE_HPET',
			'-DCONFIG_HAVE_DSO_VISIBILITY',
			'-DCONFIG_BIND_INADDR_ANY',
			'-DCONFIG_GALOIS_MUL_LUT',
		 ],
	LINKFLAGS = [	'-pipe',
			'-lm'
		    ]
)

# Branch prediction
if env['BRANCH'] == 'profile':
	env.Append(CCFLAGS = '-fprofile-arcs')
	env.Append(LINKFLAGS = '-fprofile-arcs')
elif env['BRANCH'] == 'seed':
	env.Append(CCFLAGS = '-fbranch-probabilities')

# Coverage analysis
if env['COVERAGE'] == 'full':
	env.Append(CCFLAGS = '-fprofile-arcs')
	env.Append(CCFLAGS = '-ftest-coverage')
	env.Append(LINKFLAGS = '-fprofile-arcs')
	env.Append(LINKFLAGS = '-lgcov')

# Define separate build environments
release = env.Clone(BUILD = 'release')
release.Append(CCFLAGS = '-O2')

debug = env.Clone(BUILD = 'debug')
debug.Append(CCFLAGS = '-ggdb', LINKFLAGS = '-gdb')

profile = env.Clone(BUILD = 'profile')
profile.Append(CCFLAGS = ['-O2','-pg'], LINKFLAGS = '-pg')

thirtytwo = release.Clone(BUILD = 'thirtytwo')
thirtytwo.Append(CCFLAGS = '-m32', LINKFLAGS = '-m32')

# choose and environment to build
if env['BUILD'] == 'release':
	Export({'env':release})
elif env['BUILD'] == 'profile':
	Export({'env':profile})
elif env['BUILD'] == 'thirtytwo':
	Export({'env':thirtytwo})
else:
	Export({'env':debug})

#-----------------------------------------------------------------------------
# Re-analyse dependencies

Import('env')

# vanilla environment
env.ParseConfig('pkg-config --cflags --libs glib-2.0 gthread-2.0');

# instrumentation
if env['WITH_HTTP'] == 'true' and env['WITH_HISTOGRAMS'] == 'true':
	env.Append(CCFLAGS = '-DCONFIG_HISTOGRAMS');

# managed environment for libpgmsnmp, libpgmhttp
env['SNMP_FLAGS'] = { 
        'CCFLAGS'        : [],
        'LIBS'          : [ 'netsnmpagent', 'netsnmpmibs', 'netsnmphelpers', 'netsnmp' ],
};
env['LIBSOUP_FLAGS'] = env.ParseFlags('!pkg-config --cflags --libs libsoup-2.4');

def CheckSNMP(context):
	context.Message('Checking Net-SNMP...');
	lastLIBS = context.env['LIBS'];
	lastCCFLAGS= context.env['CCFLAGS'];
	context.env.MergeFlags(env['SNMP_FLAGS']);
	result = context.TryLink("""
int main(int argc, char**argv)
{
	init_agent("PGM");
	return 0;
}
""", '.c');
	context.env.Replace(LIBS = lastLIBS, CCFLAGS=lastCCFLAGS);
	context.Result(not result);
	return result;

def CheckCheck(context):
	context.Message('Checking Check unit test framework...');
	result = context.TryAction('pkg-config --cflags --libs check')[0];
	context.Result(result);
	return result;

def CheckEventFD(context):
	context.Message('Checking eventfd...');
	result = context.TryLink("""
#include <sys/eventfd.h>
int main(int argc, char**argv)
{
	eventfd(0,0);
	return 0;
}
""", '.c')
	context.Result(result);
	return result;

tests = {
	'CheckCheck':	CheckCheck,
	'CheckEventFD':	CheckEventFD
}
if env['WITH_SNMP'] == 'true':
	tests['CheckSNMP'] = CheckSNMP;
conf = Configure(env, custom_tests = tests);

if env['WITH_SNMP'] == 'true' and not conf.CheckSNMP():
	print 'Enabling extra Red Hat dependencies for Net-SNMP.';
	conf.env['SNMP_FLAGS']['LIBS'].append(['librpm', 'libsensors', 'libdl', 'libwrap']);
	lastLIBS = conf.env['LIBS'];
	conf.env.ParseConfig('perl -MExtUtils::Embed -e ldopts');
	conf.env['SNMP_FLAGS']['LIBS'].append(conf.env['LIBS']);
	conf.env.Replace(LIBS = lastLIBS);
	if not conf.CheckSNMP():
		print 'Net-SNMP libraries not compatible.';
		Exit(1);

if env['WITH_CHECK'] == 'true' and conf.CheckCheck():
	print 'Enabling Check unit tests.';
	conf.env['CHECK'] = 'true';
else:
	print 'Disabling Check unit tests.';
	conf.env['CHECK'] = 'false';

if conf.CheckEventFD():
	print 'Enabling kernel eventfd notification mechanism.';
	conf.env.Append(CCFLAGS = '-DCONFIG_EVENTFD');

env = conf.Finish();

# DSO visibility flags
if '-DCONFIG_HAVE_DSO_VISIBILITY' in env['CCFLAGS']:
	env.Append(CCFLAGS = '-DPGM_GNUC_INTERNAL=G_GNUC_INTERNAL')
else:
	env.Append(CCFLAGS = '-DPGM_GNUC_INTERNAL=')

# add builder to create PIC static libraries for including in shared libraries
action_list = [ Action("$ARCOM", "$ARCOMSTR") ];
if env.Detect('ranlib'):
	ranlib_action = Action("$RANLIBCOM", "$RANLIBCOMSTR");
	action_list.append(ranlib_action);
pic_lib = Builder(	action = action_list,
			emitter = '$LIBEMITTER',
			prefix = '$LIBPREFIX',
			suffix = '$LIBSUFFIX',
			src_suffix = '$OBJSUFFIX',
			src_builder = 'SharedObject')
env.Append(BUILDERS = {'StaticSharedLibrary': pic_lib});


#-----------------------------------------------------------------------------

ref_node = 'ref/' + env['BUILD'] + '/';
BuildDir(ref_node, '.', duplicate=0)

env.Append(CPPPATH = os.getcwd() + '/include');
env.Append(LIBPATH = os.getcwd() + '/' + ref_node);

SConscript(ref_node + 'SConscript.libpgm');
SConscript(ref_node + 'SConscript.libpgmex');
if env['WITH_HTTP'] == 'true':
	SConscript(ref_node + 'SConscript.libpgmhttp');
if env['WITH_SNMP'] == 'true':
	SConscript(ref_node + 'SConscript.libpgmsnmp');
if env['WITH_TEST'] == 'true':
	SConscript(ref_node + 'test/SConscript');
if env['WITH_EXAMPLES'] == 'true':
	SConscript(ref_node + 'examples/SConscript');

# end of file

=== debian/changelog ===
zeromq (2.0.6beta.dfsg-2) unstable; urgency=low

  * Much improved descriptions (thanks to Martin Lucina)
  * Rename zeromq-utils to -bin to better reflect the nature of these files.

 -- Adrian von Bidder <cmot@debian.org>  Mon, 22 Mar 2010 07:05:29 +0100

zeromq (2.0.6beta.dfsg-1) unstable; urgency=low

  * New upstream version.
    - Source doesn't include non-C/C++ language bindings anymore.
    - New versioning: 2.0.6 is official upstream version which is a beta.
  * Repacked orig tar: removed non-free RFC documents (closes: #567513)
  * Improved/corrected description and copyright file, added bzip2 build
    dependency.  Thanks to feedback from zeromq mailing list.
  * Disable OpenPGM on non-x86 architectures (closes: #567848)

 -- Adrian von Bidder <cmot@debian.org>  Wed, 17 Mar 2010 10:43:40 +0100

zeromq (2.0~beta2-1) unstable; urgency=low

  * Initial package (closes: #566125)

 -- Adrian von Bidder <cmot@debian.org>  Tue, 26 Jan 2010 19:03:39 +0100

=== debian/control ===
Source: zeromq
Section: libs
Priority: optional
Maintainer: Adrian von Bidder <cmot@debian.org>
Build-Depends: debhelper (>= 7), libglib2.0-dev [amd64 i386], python [amd64 i386], uuid-dev
Standards-Version: 3.8.3
Homepage: http://www.zeromq.org/
Vcs-Browser: https://fortytwo.ch/hg/pkg-zeromq
Vcs-Hg: https://fortytwo.ch/hg/pkg-zeromq

Package: libzmq0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: zeromq-bin
Description: The ZeroMQ messaging library
 The 0MQ lightweight messaging kernel is a library which extends the
 standard socket interfaces with features traditionally provided by
 specialised messaging middleware products. 0MQ sockets provide an
 abstraction of asynchronous message queues, multiple messaging
 patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the ZeroMQ shared library.

Package: zeromq-bin
Architecture: any
Section: utils
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: zeromq-utils (<= 2.0.6beta.dfsg-1)
Replaces: zeromq-utils (<= 2.0.6beta.dfsg-1)
Description: Utilities for ZeroMQ
 The 0MQ lightweight messaging kernel is a library which extends the
 standard socket interfaces with features traditionally provided by
 specialised messaging middleware products. 0MQ sockets provide an
 abstraction of asynchronous message queues, multiple messaging
 patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the ZeroMQ devices:
 .
 zmq_queue (Forwarder device for request-response messaging)
 zmq_forwarder (Forwarder device for publish-subscribe messaging)
 zmq_streamer (Streamer device for parallelized pipeline messaging)
 .
 These are building blocks intended to serve as intermediate nodes in
 complex messaging topologies.

Package: libzmq-dev
Architecture: any
Section: libdevel
Depends: libzmq0 (= ${binary:Version}), ${misc:Depends}
Description: Development files and static library for the ZeroMQ library
 The 0MQ lightweight messaging kernel is a library which extends the
 standard socket interfaces with features traditionally provided by
 specialised messaging middleware products. 0MQ sockets provide an
 abstraction of asynchronous message queues, multiple messaging
 patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains ZeroMQ related development libraries and header files.

Package: libzmq-dbg
Architecture: any
Priority: extra
Section: debug
Depends: libzmq0 (= ${binary:Version}), ${misc:Depends}
Description: Debugging files for the ZeroMQ messaging library
 The 0MQ lightweight messaging kernel is a library which extends the
 standard socket interfaces with features traditionally provided by
 specialised messaging middleware products. 0MQ sockets provide an
 abstraction of asynchronous message queues, multiple messaging
 patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the debugging synmbols of the ZeroMQ library.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifneq (,$(filter $(DEB_HOST_ARCH),i386 amd64))
    pgm_opt := --with-pgm
else
    pgm_opt :=
endif

configure: configure-stamp
configure-stamp:
	dh_testdir

	# hack: check that we're building from dsfg-free orig tarball
	if tar tzf foreign/openpgm/libpgm-*.tar.gz | grep -q rfc3208.txt;then \
	    echo "Remove RFC documents from orig tar."; \
	    exit 1; \
	fi

	./configure $(CROSS) \
	    --prefix=/usr \
	    $(pgm_opt) \
	    CFLAGS="$(CFLAGS)" \
	    LDFLAGS="-Wl,--as-needed -Wl,-z,defs" \

	touch configure-stamp

build: build-stamp

build-stamp: configure-stamp
	dh_testdir

	$(MAKE)

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	if [ -e Makefile ]; then make distclean; fi
	rm -rf foreign/openpgm/libpgm-2.0.20rc5 config.log

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install


binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_install -X/usr/share/man --fail-missing
	dh_installman
	dh_installchangelogs
	dh_installdocs
	dh_lintian
	dh_link
	dh_strip --dbg-package=libzmq-dbg
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

# vim: set filetype=make


# build depends:
#  - python[-all]-dev
#  - ruby-dev
#    -> figure out ruby-headersdir option automatically
#  - openjdk-6-jdk (or whatever)
#    -> set JAVA_HOME automatically
#  - libglib2.0-dev

## zeromq 2.0.10

=== openpgm/pgm/SConstruct ===
--- 
+++ 
@@ -107,6 +107,9 @@
 			'-D_REENTRANT',
 			'-D_GNU_SOURCE',
 			'-D__need_IOV_MAX',
+			'-DCONFIG_16BIT_CHECKSUM',
+			'-DCONFIG_HAVE_PROC',
+			'-DCONFIG_HAVE_BACKTRACE',
 			'-DCONFIG_HAVE_PSELECT',
 			'-DCONFIG_HAVE_POLL',
 			'-DCONFIG_HAVE_PPOLL',

=== debian/changelog ===
zeromq (2.0.10-1build1) natty; urgency=low

  * No-change rebuild to pick up multiarch .la files

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Apr 2011 11:11:41 -0700

zeromq (2.0.10-1) unstable; urgency=low

  * New upstream version.
  * Upstream now uses DFSG-clean OpenPGM tarball, so dropping .dfsg from 
    the Debian version.

 -- Martin Lucina <mato@kotelna.sk>  Thu, 21 Oct 2010 16:21:20 +0200

zeromq (2.0.9.dfsg-1) unstable; urgency=medium

  * New upstream version. 
  * Move all manpages in libzmq0 to zeromq-dev package (closes: #595890) 
  * Updated to standards version 3.9.1.
  * Add lintian-overrides for spelling-error-in-copyright due to error in
    upstream license of xmlParser.
  * Use Breaks: instead of Conflicts: in zeromq-bin package, fixes 
    conflicts-with-version from lintian.
  * Various other minor fixes for warnings from lintian.

 -- Martin Lucina <mato@kotelna.sk>  Wed, 08 Sep 2010 15:25:45 +0200

zeromq (2.0.7.dfsg-1) unstable; urgency=low

  * New upstream version.
  * Reformatted package description, thanks to Rhonda (closes: #577549)
  * Added AUTHORS, NEWS and README to installed documentation.
  * New maintainer (closes: #587505)

 -- Martin Lucina <mato@kotelna.sk>  Wed, 30 Jun 2010 12:31:08 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,13 @@
 Source: zeromq
 Section: libs
 Priority: optional
-Maintainer: Adrian von Bidder <cmot@debian.org>
+Maintainer: Martin Lucina <mato@kotelna.sk>
 Build-Depends: debhelper (>= 7), libglib2.0-dev [amd64 i386], python [amd64 i386], uuid-dev
-Standards-Version: 3.8.3
+Standards-Version: 3.9.1
 Homepage: http://www.zeromq.org/
-Vcs-Browser: https://fortytwo.ch/hg/pkg-zeromq
-Vcs-Hg: https://fortytwo.ch/hg/pkg-zeromq
 
 Package: libzmq0
 Architecture: any
-Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: zeromq-bin
 Description: The ZeroMQ messaging library
@@ -27,7 +24,7 @@
 Architecture: any
 Section: utils
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: zeromq-utils (<= 2.0.6beta.dfsg-1)
+Breaks: zeromq-utils (<= 2.0.6beta.dfsg-1)
 Replaces: zeromq-utils (<= 2.0.6beta.dfsg-1)
 Description: Utilities for ZeroMQ
  The 0MQ lightweight messaging kernel is a library which extends the
@@ -39,9 +36,9 @@
  .
  This package contains the ZeroMQ devices:
  .
- zmq_queue (Forwarder device for request-response messaging)
- zmq_forwarder (Forwarder device for publish-subscribe messaging)
- zmq_streamer (Streamer device for parallelized pipeline messaging)
+  * zmq_queue (Forwarder device for request-response messaging)
+  * zmq_forwarder (Forwarder device for publish-subscribe messaging)
+  * zmq_streamer (Streamer device for parallelized pipeline messaging)
  .
  These are building blocks intended to serve as intermediate nodes in
  complex messaging topologies.

=== debian/rules ===
--- 
+++ 
@@ -10,15 +10,15 @@
     pgm_opt :=
 endif
 
+ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+    MAKEFLAGS += -j$(NUMJOBS)
+endif
+
+
 configure: configure-stamp
 configure-stamp:
 	dh_testdir
-
-	# hack: check that we're building from dsfg-free orig tarball
-	if tar tzf foreign/openpgm/libpgm-*.tar.gz | grep -q rfc3208.txt;then \
-	    echo "Remove RFC documents from orig tar."; \
-	    exit 1; \
-	fi
 
 	./configure $(CROSS) \
 	    --prefix=/usr \
@@ -33,7 +33,7 @@
 build-stamp: configure-stamp
 	dh_testdir
 
-	$(MAKE)
+	$(MAKE) $(MAKEFLAGS)
 
 	touch $@

## zeromq 2.1.7

=== debian/changelog ===
zeromq (2.1.7-1~natty1) natty-backports; urgency=low

  * Automated backport upload; no source changes.

 -- Evan Broder <evan@ebroder.net>  Fri, 12 Aug 2011 11:51:50 +0000

zeromq (2.1.7-1) unstable; urgency=low

  * New upstream version. (closes: #619374)
  * --with-system-pgm is now used instead of the embedded OpenPGM library. 
  * Added Debian watch file.

 -- Martin Lucina <mato@kotelna.sk>  Fri, 13 May 2011 12:43:09 +0200

zeromq (2.1.4-1) experimental; urgency=low

  * New upstream version.
  * OpenPGM re-enabled for amd64 and i386, still using embedded library.

 -- Martin Lucina <mato@kotelna.sk>  Thu, 07 Apr 2011 15:37:46 +0200

zeromq (2.1.3-1) experimental; urgency=low

  * New upstream version.
  * The zeromq-bin package has been removed, as upstream has removed the
    devices.
  * Temporarily disabled OpenPGM builds on i386 and amd64 due to changes in
    upstream OpenPGM intergration. 

 -- Martin Lucina <mato@kotelna.sk>  Mon, 28 Mar 2011 10:39:51 +0200

=== debian/control ===
Source: zeromq
Section: libs
Priority: optional
Maintainer: Martin Lucina <mato@kotelna.sk>
Build-Depends: debhelper (>= 7), uuid-dev, libpgm-dev, pkg-config
Standards-Version: 3.9.2
Homepage: http://www.zeromq.org/

Package: libzmq1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ZeroMQ lightweight messaging kernel (shared library)
 The 0MQ lightweight messaging kernel is a library which extends the
 standard socket interfaces with features traditionally provided by
 specialised messaging middleware products. 0MQ sockets provide an
 abstraction of asynchronous message queues, multiple messaging
 patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the ZeroMQ shared library.

Package: libzmq-dev
Architecture: any
Section: libdevel
Depends: libzmq1 (= ${binary:Version}), ${misc:Depends}
Description: ZeroMQ lightweight messaging kernel (development libraries and header files)
 The 0MQ lightweight messaging kernel is a library which extends the
 standard socket interfaces with features traditionally provided by
 specialised messaging middleware products. 0MQ sockets provide an
 abstraction of asynchronous message queues, multiple messaging
 patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the ZeroMQ development libraries and header
 files.

Package: libzmq-dbg
Architecture: any
Priority: extra
Section: debug
Depends: libzmq1 (= ${binary:Version}), ${misc:Depends}
Description: ZeroMQ lightweight messaging kernel (debugging symbols)
 The 0MQ lightweight messaging kernel is a library which extends the
 standard socket interfaces with features traditionally provided by
 specialised messaging middleware products. 0MQ sockets provide an
 abstraction of asynchronous message queues, multiple messaging
 patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the debugging synmbols for the ZeroMQ library.

=== debian/rules ===
--- 
+++ 
@@ -1,14 +1,6 @@
 #!/usr/bin/make -f
 
 #export DH_VERBOSE=1
-
-DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
-
-ifneq (,$(filter $(DEB_HOST_ARCH),i386 amd64))
-    pgm_opt := --with-pgm
-else
-    pgm_opt :=
-endif
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
     NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -22,7 +14,7 @@
 
 	./configure $(CROSS) \
 	    --prefix=/usr \
-	    $(pgm_opt) \
+	    --with-system-pgm \
 	    CFLAGS="$(CFLAGS)" \
 	    LDFLAGS="-Wl,--as-needed -Wl,-z,defs" \
 
@@ -43,7 +35,6 @@
 	rm -f build-stamp configure-stamp
 
 	if [ -e Makefile ]; then make distclean; fi
-	rm -rf foreign/openpgm/libpgm-2.0.20rc5 config.log
 
 	dh_clean
 
@@ -81,12 +72,3 @@
 .PHONY: build clean binary-indep binary-arch binary install configure
 
 # vim: set filetype=make
-
-
-# build depends:
-#  - python[-all]-dev
-#  - ruby-dev
-#    -> figure out ruby-headersdir option automatically
-#  - openjdk-6-jdk (or whatever)
-#    -> set JAVA_HOME automatically
-#  - libglib2.0-dev

## zeromq 2.1.9

=== debian/changelog ===
zeromq (2.1.9-1) unstable; urgency=low

  * New upstream version. 

 -- Martin Lucina <mato@kotelna.sk>  Thu, 08 Sep 2011 16:38:46 +0200

=== debian/rules ===
--- 
+++ 
@@ -20,7 +20,9 @@
 
 	touch configure-stamp
 
-build: build-stamp
+build: build-arch build-indep
+build-arch: build-stamp
+build-indep: build-stamp
 
 build-stamp: configure-stamp
 	dh_testdir
@@ -50,6 +52,7 @@
 binary-indep: build install
 
 binary-arch: build install
+	sed -i "/dependency_libs/ s/'.*'/''/" `find . -name '*.la'`
 	dh_testdir
 	dh_testroot
 	dh_install -X/usr/share/man --fail-missing

=== debian/watch ===
version=3
http://download.zeromq.org/zeromq-(.*)\.tar\.gz

## zeromq 2.1.10

=== debian/changelog ===
zeromq (2.1.10-1) unstable; urgency=low

  * New upstream version. 

 -- Martin Lucina <mato@kotelna.sk>  Mon, 03 Oct 2011 17:09:06 +0200

## zeromq 2.1.11

=== debian/changelog ===
zeromq (2.1.11-1ubuntu1) precise; urgency=low

  * Merge with debian unstable (LP: #925649). Remaining changes
    - sock_cloexec-runtime-check.patch: (LP: #910757)
      check at runtime for SOCK_CLOEXEC support in kernel
      allows using testsuite on builders running 2.6.24

 -- Julian Taylor <jtaylor@ubuntu.com>  Sun, 19 Feb 2012 15:40:32 +0100

zeromq (2.1.11-1) unstable; urgency=low

  * [4016b65] Imported Upstream version 2.1.11
  * [eaa74d0] Maintainer e-mail address changed
  * [9943256] Run testsuite during build (Closes: #655620)
  * [5ea0ff8] Remove unneeded libzmq.la from libzmq-dev (Closes: #633292)

 -- Martin Lucina <martin@lucina.net>  Mon, 23 Jan 2012 11:14:23 +0100

zeromq (2.1.10-1ubuntu1) precise; urgency=low

  * sock_cloexec-runtime-check.patch: (LP: #910757)
    check at runtime for SOCK_CLOEXEC support in kernel
    allows using testsuite on builders running 2.6.24

 -- Julian Taylor <jtaylor@ubuntu.com>  Thu, 19 Jan 2012 18:43:25 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: zeromq
 Section: libs
 Priority: optional
-Maintainer: Martin Lucina <mato@kotelna.sk>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Martin Lucina <mato@kotelna.sk>
 Build-Depends: debhelper (>= 7), uuid-dev, libpgm-dev, pkg-config
 Standards-Version: 3.9.2
 Homepage: http://www.zeromq.org/

=== debian/rules ===
--- 
+++ 
@@ -29,6 +29,10 @@
 
 	$(MAKE) $(MAKEFLAGS)
 
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	$(MAKE) check
+endif
+
 	touch $@
 
 clean:
@@ -52,10 +56,9 @@
 binary-indep: build install
 
 binary-arch: build install
-	sed -i "/dependency_libs/ s/'.*'/''/" `find . -name '*.la'`
 	dh_testdir
 	dh_testroot
-	dh_install -X/usr/share/man --fail-missing
+	dh_install -X/usr/share/man -X/usr/lib/libzmq.la --fail-missing
 	dh_installman
 	dh_installchangelogs
 	dh_installdocs

## zeromq 2.2.0%2Bdfsg

=== debian/changelog ===
zeromq (2.2.0+dfsg-7) unstable; urgency=low

  * Build with OpenPGM 5.2 version.
  * Update copyright file.
  * Update Standards-Version to 3.9.7 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 21 Feb 2016 08:47:12 +0100

zeromq (2.2.0+dfsg-6) unstable; urgency=low

  * Make test failures non-fatal on kfreebsd-* .
  * New maintainer (closes: #741745).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 20 Mar 2014 23:22:55 +0100

zeromq (2.2.0+dfsg-5) unstable; urgency=medium

  * Bump Standards-Version to 3.9.5 (no changes needed)
  * Use dh-autoreconf instead of autotools-dev (Closes: #735094)
  * Make Vcs-* fields canonical

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 12 Jan 2014 19:13:20 +0100

zeromq (2.2.0+dfsg-4) unstable; urgency=low

  * Also add 02_check-for-SO_NOSIGPIPE.patch for kfreebsd FTBFS

 -- Alessandro Ghedini <ghedo@debian.org>  Fri, 17 May 2013 19:33:11 +0200

zeromq (2.2.0+dfsg-3) unstable; urgency=low

  * Use repack.{local,stub} instead of get-orig-source rule
  * Bump Standards-Version to 3.9.4 (no changes needed)
  * Fix typo in libzmq-dbg description (Closes: #696744)
  * Add 01_fix-kfreebsd-build.patch to fix FTBFS on kfreebsd (Closes: #637777)

 -- Alessandro Ghedini <ghedo@debian.org>  Fri, 17 May 2013 18:06:40 +0200

zeromq (2.2.0+dfsg-2) unstable; urgency=low

  * Make -dev package Multi-Arch: same too (Closes: #674601)

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 03 Jun 2012 13:29:40 +0200

zeromq (2.2.0+dfsg-1) unstable; urgency=low

  * New maintainer (Closes: #673619)
  * Repack upstream tarball to remove bundled openpgm tarball and xmlParser
    - Mangle dversion in watch file
  * Switch to short-form dh rules file
    - Use autotools-dev plugin
  * Bump debhelper compat level to 9
  * Update copyright file using Copyright-Format 1.0
  * Remove source options
  * Remove unused lintian overrides
  * Add Multi-Arch headers
    - Fix *.install files to use multi-arch paths
  * Vcs-* tags point to collab-maint repository
  * Fix short and long descriptions formatting
  * Ignore beta 3.x releases in watch file
  * Remove outdated and uselss README.Debian

 -- Alessandro Ghedini <ghedo@debian.org>  Tue, 22 May 2012 22:24:49 +0200

zeromq (2.2.0-1) unstable; urgency=low

  * [5661946] Imported Upstream version 2.2.0 (Closes: #672427)
  * [bbf467d] Bump Standards-Version to 3.9.3 with no changes
  * [0da0708] Add Vcs-Git and Vcs-Browser to debian/control

 -- Martin Lucina <martin@lucina.net>  Sun, 20 May 2012 11:27:32 +0200

## zeromq 2.2.0+dfsg

=== debian/control ===
Source: zeromq
Section: libs
Priority: optional
Maintainer: Alessandro Ghedini <ghedo@debian.org>
Build-Depends: debhelper (>= 9),
 autotools-dev,
 libpgm-dev,
 pkg-config,
 uuid-dev
Standards-Version: 3.9.3
Vcs-Browser: http://git.debian.org/?p=collab-maint/zeromq.git
Vcs-Git: git://git.debian.org/collab-maint/zeromq.git
Homepage: http://www.zeromq.org/

Package: libzmq1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: lightweight messaging kernel (shared library)
 ØMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ØMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the ZeroMQ shared library.

Package: libzmq-dev
Architecture: any
Section: libdevel
Depends: libzmq1 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: lightweight messaging kernel (development files)
 ØMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ØMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the ZeroMQ development libraries and header files.

Package: libzmq-dbg
Architecture: any
Priority: extra
Section: debug
Depends: libzmq1 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: lightweight messaging kernel (debugging symbols)
 ØMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ØMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the debugging synmbols for the ZeroMQ library.

=== debian/rules ===
#!/usr/bin/make -f

DEB_SOURCE_NAME=zeromq
DEB_UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^+]+).*,\1,p')

%:
	dh $@ --with=autotools-dev

override_dh_auto_configure:
	dh_auto_configure -- --with-system-pgm

override_dh_strip:
	dh_strip --dbg-package=libzmq-dbg

get-orig-source:
	uscan --noconf --rename --download-current-version --destdir=.
	tar -xf $(DEB_SOURCE_NAME)_$(DEB_UPSTREAM_VERSION).orig.tar.gz
	rm $(DEB_SOURCE_NAME)_$(DEB_UPSTREAM_VERSION).orig.tar.gz
	$(RM) $(DEB_SOURCE_NAME)-$(DEB_UPSTREAM_VERSION)/foreign/openpgm/*.gz
	$(RM) -r $(DEB_SOURCE_NAME)-$(DEB_UPSTREAM_VERSION)/foreign/xmlParser
	mv $(DEB_SOURCE_NAME)-$(DEB_UPSTREAM_VERSION) $(DEB_SOURCE_NAME)-$(DEB_UPSTREAM_VERSION).orig
	GZIP=--best tar -cz --owner root --group root --mode a+rX \
		-f $(DEB_SOURCE_NAME)_$(DEB_UPSTREAM_VERSION)+dfsg.orig.tar.gz \
		$(DEB_SOURCE_NAME)-$(DEB_UPSTREAM_VERSION).orig
	rm -r $(DEB_SOURCE_NAME)-$(DEB_UPSTREAM_VERSION).orig

=== debian/watch ===
version=3

options=dversionmangle=s/\+dfsg// \
http://download.zeromq.org/zeromq-(2.*)\.tar\.gz

## zeromq 4.3.5

=== debian/changelog ===
zeromq (4.3.5-0) UNRELEASED; urgency=low

  * Initial packaging.

 -- libzmq Developers <zeromq-dev@lists.zeromq.org>  Wed, 31 Dec 2014 00:00:00 +0000

## zeromq 4.3.5+git20260123

=== debian/changelog ===
zeromq (4.3.5+git20260123-0) UNRELEASED; urgency=low

  * Initial packaging.

 -- libzmq Developers <zeromq-dev@lists.zeromq.org>  Wed, 31 Dec 2014 00:00:00 +0000

## zeromq 1488546787.34be53d

=== CMakeLists.txt ===
# CMake build script for ZeroMQ

cmake_minimum_required (VERSION 2.8.12)
project (ZeroMQ)

list (INSERT CMAKE_MODULE_PATH 0 "${CMAKE_SOURCE_DIR}")

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=gnu++11" COMPILER_SUPPORTS_CXX11)
if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
endif()
include(CheckCCompilerFlag)
CHECK_C_COMPILER_FLAG("-std=gnu11" COMPILER_SUPPORTS_C11)
if(COMPILER_SUPPORTS_C11)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
endif()

# Will be used to add flags to pkg-config useful when apps want to statically link
set (pkg_config_libs_private "")

option (WITH_OPENPGM "Build with support for OpenPGM" OFF)
option (WITH_VMCI "Build with support for VMware VMCI socket" OFF)

if (APPLE)
    option (ZMQ_BUILD_FRAMEWORK "Build as OS X framework" OFF)
endif ()

# Select curve encryption library, defaults to tweetnacl
# To use libsodium instead, use --with-libsodium (must be installed)
# To disable curve, use --disable-curve

option (WITH_LIBSODIUM "Use libsodium instead of built-in tweetnacl" OFF)
option (ENABLE_CURVE "Enable CURVE security" ON)

if (NOT ENABLE_CURVE)
    message (STATUS "CURVE security is disabled")

elseif (WITH_LIBSODIUM)
    find_package (Sodium)
    if (SODIUM_FOUND)
        message (STATUS "Using libsodium for CURVE security")
        include_directories (${SODIUM_INCLUDE_DIRS})

        # On Solaris, libsodium depends on libssp
        if (${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
            target_link_libraries (libzmq ssp)
        endif ()
        set (ZMQ_USE_LIBSODIUM 1)
        set (ZMQ_HAVE_CURVE 1)
        set (pkg_config_libs_private "${pkg_config_libs_private} -lsodium")
    else ()
        message (FATAL_ERROR
            "libsodium is not installed. Install it, then run CMake again")
    endif ()

else ()
    message (STATUS "Using tweetnacl for CURVE security")
    list (APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/src/tweetnacl.c)
    set (ZMQ_USE_TWEETNACL 1)
    set (ZMQ_HAVE_CURVE 1)
endif ()

set(SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")

if (EXISTS "${SOURCE_DIR}/.git")
    OPTION (ENABLE_DRAFTS "Build and install draft classes and methods" ON)
else ()
    OPTION (ENABLE_DRAFTS "Build and install draft classes and methods" OFF)
endif ()
IF (ENABLE_DRAFTS)
    ADD_DEFINITIONS (-DZMQ_BUILD_DRAFT_API)
    set (pkg_config_defines "-DZMQ_BUILD_DRAFT_API=1")
ELSE (ENABLE_DRAFTS)
    set (pkg_config_defines "")
ENDIF (ENABLE_DRAFTS)

option (WITH_MILITANT "Enable militant assertions" OFF)
if (WITH_MILITANT)
    add_definitions(-DZMQ_ACT_MILITANT)
endif()

set (POLLER "" CACHE STRING "Choose polling system. valid values are
                            kqueue, epoll, devpoll, pollset, poll or select [default=autodetect]")

include (CheckFunctionExists)
include (CheckTypeSize)

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES sys/event.h)
    check_function_exists (kqueue HAVE_KQUEUE)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_KQUEUE)
        set (POLLER "kqueue")
    endif()
endif ()

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES sys/epoll.h)
    check_function_exists (epoll_create HAVE_EPOLL)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_EPOLL)
        set (POLLER "epoll")
        check_function_exists (epoll_create1 HAVE_EPOLL_CLOEXEC)
        if (HAVE_EPOLL_CLOEXEC)
            set (ZMQ_USE_EPOLL_CLOEXEC 1)
        endif ()
    endif ()
endif ()

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES sys/devpoll.h)
    check_type_size ("struct pollfd" DEVPOLL)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_DEVPOLL)
        set (POLLER "devpoll")
    endif ()
endif ()

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES sys/pollset.h)
    check_function_exists (pollset_create HAVE_POLLSET)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_POLLSET)
        set (POLLER "pollset")
    endif()
endif ()

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES poll.h)
    check_function_exists (poll HAVE_POLL)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_POLL)
        set (POLLER "poll")
    endif ()
endif ()

if (POLLER STREQUAL "")
    if (WIN32)
        set (CMAKE_REQUIRED_INCLUDES winsock2.h)
        set (HAVE_SELECT 1)
    else ()
        set (CMAKE_REQUIRED_INCLUDES sys/select.h)
        check_function_exists (select HAVE_SELECT)
        set (CMAKE_REQUIRED_INCLUDES)
    endif ()
    if (HAVE_SELECT)
        set (POLLER "select")
    else ()
        message (FATAL_ERROR
            "Could not autodetect polling method")
    endif ()
endif ()

if (POLLER STREQUAL "kqueue"
 OR POLLER STREQUAL "epoll"
 OR POLLER STREQUAL "devpoll"
 OR POLLER STREQUAL "pollset"
 OR POLLER STREQUAL "poll"
 OR POLLER STREQUAL "select")
    message (STATUS "Detected ${POLLER} polling method")
    string (TOUPPER ${POLLER} UPPER_POLLER)
    set (ZMQ_USE_${UPPER_POLLER} 1)
else ()
    message (FATAL_ERROR "Invalid polling method")
endif ()

set (ZMQ_CMAKE_MODULES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/builds/cmake/Modules)
list (APPEND CMAKE_MODULE_PATH ${ZMQ_CMAKE_MODULES_DIR})

include (TestZMQVersion)
include (ZMQSourceRunChecks)
include (CheckIncludeFiles)
include (CheckLibraryExists)
include (CheckCCompilerFlag)
include (CheckCXXCompilerFlag)
include (CheckCSourceCompiles)
include (CheckCSourceRuns)
include (CMakeDependentOption)
include (CheckCXXSymbolExists)

check_include_files (ifaddrs.h ZMQ_HAVE_IFADDRS)
check_include_files (windows.h ZMQ_HAVE_WINDOWS)
check_include_files (sys/uio.h ZMQ_HAVE_UIO)
check_include_files (sys/eventfd.h ZMQ_HAVE_EVENTFD)
if (ZMQ_HAVE_EVENTFD)
  zmq_check_efd_cloexec ()
endif ()

check_library_exists (ws2_32 fopen "" HAVE_WS2_32) # TODO: Why doesn't something logical like WSAStartup work?
check_library_exists (ws2 fopen "" HAVE_WS2)
check_library_exists (rpcrt4 fopen "" HAVE_RPCRT4) # UuidCreateSequential
check_library_exists (iphlpapi fopen "" HAVE_IPHLAPI) # GetAdaptersAddresses

check_cxx_symbol_exists (SO_PEERCRED sys/socket.h ZMQ_HAVE_SO_PEERCRED)
check_cxx_symbol_exists (LOCAL_PEERCRED sys/socket.h ZMQ_HAVE_LOCAL_PEERCRED)

find_library (RT_LIBRARY rt)

find_package (Threads)


if (WIN32 AND NOT CYGWIN)
  if (NOT HAVE_WS2_32 AND NOT HAVE_WS2)
    message (FATAL_ERROR "Cannot link to ws2_32 or ws2")
  endif ()

  if (NOT HAVE_RPCRT4)
    message (FATAL_ERROR "Cannot link to rpcrt4")
  endif ()

  if (NOT HAVE_IPHLAPI)
    message (FATAL_ERROR "Cannot link to iphlapi")
  endif ()
endif ()

set (CMAKE_REQUIRED_LIBRARIES rt)
check_function_exists (clock_gettime HAVE_CLOCK_GETTIME)
set (CMAKE_REQUIRED_LIBRARIES)

set (CMAKE_REQUIRED_INCLUDES unistd.h)
check_function_exists (fork HAVE_FORK)
set (CMAKE_REQUIRED_INCLUDES)

set (CMAKE_REQUIRED_INCLUDES sys/time.h)
check_function_exists (gethrtime HAVE_GETHRTIME)
set (CMAKE_REQUIRED_INCLUDES)

set (CMAKE_REQUIRED_INCLUDES stdlib.h)
check_function_exists (mkdtemp HAVE_MKDTEMP)
set (CMAKE_REQUIRED_INCLUDES)

add_definitions (-D_REENTRANT -D_THREAD_SAFE)
add_definitions (-DZMQ_CUSTOM_PLATFORM_HPP)

option (ENABLE_EVENTFD "Enable/disable eventfd" ZMQ_HAVE_EVENTFD)

macro (zmq_check_cxx_flag_prepend flag)
  check_cxx_compiler_flag ("${flag}" HAVE_FLAG_${flag})

  if (HAVE_FLAG_${flag})
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
  endif ()
endmacro ()


if (MSVC)
  zmq_check_cxx_flag_prepend ("/W3")

  if (MSVC_IDE)
    set (MSVC_TOOLSET "-${CMAKE_VS_PLATFORM_TOOLSET}")
  else ()
    set (MSVC_TOOLSET "")
  endif ()
else ()
  zmq_check_cxx_flag_prepend ("-Wall")
endif ()

if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  zmq_check_cxx_flag_prepend ("-Wextra")
endif ()

#   TODO: why is -Wno-long-long defined differently than in configure.ac?
zmq_check_cxx_flag_prepend ("-Wno-long-long")
zmq_check_cxx_flag_prepend ("-Wno-uninitialized")

option (LIBZMQ_PEDANTIC "" ON)
option (LIBZMQ_WERROR "" OFF)

if (LIBZMQ_PEDANTIC)
  zmq_check_cxx_flag_prepend ("-pedantic")

  if (${CMAKE_CXX_COMPILER_ID} MATCHES "Intel")
    zmq_check_cxx_flag_prepend ("-strict-ansi")
  endif ()

  if (${CMAKE_CXX_COMPILER_ID} MATCHES "SunPro")
    zmq_check_cxx_flag_prepend ("-compat=5")
  endif ()
endif ()

if (LIBZMQ_WERROR)
  zmq_check_cxx_flag_prepend ("-Werror")
  zmq_check_cxx_flag_prepend ("-errwarn=%all")
endif ()


if (CMAKE_SYSTEM_PROCESSOR MATCHES "^sparc")
  zmq_check_cxx_flag_prepend ("-mcpu=v9")
endif ()

if (${CMAKE_CXX_COMPILER_ID} MATCHES "SunPro")
  zmq_check_cxx_flag_prepend ("-features=zla")
endif ()


if (CMAKE_SYSTEM_NAME MATCHES "SunOS" OR CMAKE_SYSTEM_NAME MATCHES "NetBSD")
  message (STATUS "Checking whether atomic operations can be used")
  check_c_source_compiles (
  "
   #include <atomic.h>

    int main ()
    {
      uint32_t value;
      atomic_cas_32 (&value, 0, 0);
      return 0;
    }
    "
    HAVE_ATOMIC_H)

  if (NOT HAVE_ATOMIC_H)
    set (ZMQ_FORCE_MUTEXES 1)
  endif ()
endif ()


#-----------------------------------------------------------------------------
zmq_check_sock_cloexec ()
zmq_check_so_keepalive ()
zmq_check_tcp_keepcnt ()
zmq_check_tcp_keepidle ()
zmq_check_tcp_keepintvl ()
zmq_check_tcp_keepalive ()
zmq_check_tcp_tipc ()


if (    CMAKE_SYSTEM_NAME MATCHES "Linux"
    OR CMAKE_SYSTEM_NAME MATCHES "GNU/kFreeBSD"
    OR CMAKE_SYSTEM_NAME MATCHES "GNU/Hurd"
    OR CYGWIN)
  add_definitions (-D_GNU_SOURCE)
elseif (CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  add_definitions (-D__BSD_VISIBLE)
elseif (CMAKE_SYSTEM_NAME MATCHES "NetBSD")
  add_definitions (-D_NETBSD_SOURCE)
elseif (CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
  add_definitions (-D_OPENBSD_SOURCE)
elseif (CMAKE_SYSTEM_NAME MATCHES "SunOS")
  add_definitions (-D_PTHREADS)
elseif (CMAKE_SYSTEM_NAME MATCHES "HP-UX")
  add_definitions (-D_POSIX_C_SOURCE=200112L)
  zmq_check_cxx_flag_prepend (-Ae)
elseif (CMAKE_SYSTEM_NAME MATCHES "Darwin")
  add_definitions (-D_DARWIN_C_SOURCE)
endif ()

set (CMAKE_PYTHON_VERSION 2.7 2.6 2.5 2.4)
find_package (PythonInterp)
find_package (AsciiDoc)

cmake_dependent_option (WITH_DOC "Build Reference Guide documentation (requires DocBook)" ON
                       "PYTHONINTERP_FOUND;ASCIIDOC_FOUND" OFF)

if (MSVC)
  if (WITH_OPENPGM)
    #   set (OPENPGM_ROOT "" CACHE PATH "Location of OpenPGM")
    set (OPENPGM_VERSION_MAJOR 5)
    set (OPENPGM_VERSION_MINOR 2)
    set (OPENPGM_VERSION_MICRO 122)
    if (CMAKE_CL_64)
      find_path (OPENPGM_ROOT include/pgm/pgm.h
                PATHS
                "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Miru\\OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}]"
                NO_DEFAULT_PATH
               )
      message (STATUS "OpenPGM x64 detected - ${OPENPGM_ROOT}")
    else ()
      find_path (OPENPGM_ROOT include/pgm/pgm.h
                PATHS
                "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Wow6432Node\\Miru\\OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}]"
                "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Miru\\OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}]"
                NO_DEFAULT_PATH
               )
      message (STATUS "OpenPGM x86 detected - ${OPENPGM_ROOT}")
    endif (CMAKE_CL_64)
    set (OPENPGM_INCLUDE_DIRS ${OPENPGM_ROOT}/include)
    set (OPENPGM_LIBRARY_DIRS ${OPENPGM_ROOT}/lib)
    set (OPENPGM_LIBRARIES
      optimized libpgm${MSVC_TOOLSET}-mt-${OPENPGM_VERSION_MAJOR}_${OPENPGM_VERSION_MINOR}_${OPENPGM_VERSION_MICRO}.lib
      debug libpgm${MSVC_TOOLSET}-mt-gd-${OPENPGM_VERSION_MAJOR}_${OPENPGM_VERSION_MINOR}_${OPENPGM_VERSION_MICRO}.lib)
  endif ()
else ()
  if (WITH_OPENPGM)
    #  message (FATAL_ERROR "WITH_OPENPGM not implemented")
    
    if (NOT OPENPGM_PKGCONFIG_NAME)
      SET (OPENPGM_PKGCONFIG_NAME "openpgm-5.2")
    endif(NOT OPENPGM_PKGCONFIG_NAME)
    
    SET (OPENPGM_PKGCONFIG_NAME ${OPENPGM_PKGCONFIG_NAME} CACHE STRING 
      "Name pkg-config shall use to find openpgm libraries and include paths"
      FORCE )
    
    find_package(PkgConfig)
